package ru.linuxformat;

import java.io.*;
import java.util.*;

public class Contacter {
    private static Contacter _instance = new Contacter();

    private List<Contact> _contacts = new ArrayList<Contact>();

    public static Contacter getInstance() {
        return _instance;
    }

    public Contacter() {
        File file = new File(System.getProperty("user.home") + "/AddressBook/contacts.serialized.data");
        if (file.exists()) {
            try {
                ObjectInputStream stream = new ObjectInputStream(new FileInputStream(file));
                _contacts = (List<Contact>) stream.readObject();
                stream.close();
            } catch (Exception e) {
                _contacts.add(new Contact("Test", "1234567", "Comment", 1234));
            }
        }
    }

    public void saveContacts() {
        File file = new File(System.getProperty("user.home") + "/AddressBook/contacts.serialized.data");
        if (!file.getParentFile().exists()) {
            file.getParentFile().mkdirs();
        }

        try {
            ObjectOutputStream stream = new ObjectOutputStream(new FileOutputStream(file));
            stream.writeObject(_contacts);
            stream.close();
        } catch (IOException e) {
            e.printStackTrace();
        }
    }

    public Set<Contact> getContactsSortedByName() {
        Set<Contact> result = new TreeSet<Contact>(new Comparator<Contact>() {
            public int compare(Contact o1, Contact o2) {
                return o1.getName().compareTo(o2.getName());
            }
        });

        result.addAll(_contacts);

        return result;
    }

    public Set<Contact> getContactsSortedByNameReversed() {
        Set<Contact> result = new TreeSet<Contact>(new Comparator<Contact>() {
            public int compare(Contact o1, Contact o2) {
                return o2.getName().compareTo(o1.getName());
            }
        });

        result.addAll(_contacts);

        return result;
    }

    public Contact getContactByName(String aName) {
        for (Contact contact : _contacts) {
            if (contact.getName().equals(aName)) {
                return contact;
            }
        }

        return null;
    }

    public void addContact(String aName, String aPhone, String aComment, int aAge) {
        _contacts.add(new Contact(aName, aPhone, aComment, aAge));
        saveContacts();
    }
}
